//+------------------------------------------------------------------+
//|                                                          RSI.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 8
#property indicator_color8 DodgerBlue
#property indicator_width8 2
#property indicator_color1 DeepSkyBlue
#property indicator_style1 0
#property indicator_color2 Orange
#property indicator_style2 2
#property indicator_color3 DeepSkyBlue
#property indicator_style3 2
#property indicator_color4 Orange
#property indicator_style4 0

#property indicator_color5 Gray
#property indicator_style5 2



//---- input parameters
extern int RSIPeriod=14;
extern int Level1 = 80;
extern int Level2 = 60;
extern int Level3 = 40;
extern int Level4 = 20;
extern int Level5 = 50;
//---- buffers
double RSIBuffer[];
double PosBuffer[];
double NegBuffer[];
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(8);
   SetIndexBuffer(5,PosBuffer);
   SetIndexBuffer(6,NegBuffer);
//---- indicator line
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,RSIBuffer);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Buffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Buffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,Buffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,Buffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,Buffer5);
   
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");
   SetIndexLabel(4,"");
   SetIndexLabel(5,"");
   SetIndexLabel(6,"");
//---- name for DataWindow and indicator subwindow label
   short_name="RSI("+RSIPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(7,short_name);
//----
   SetIndexDrawBegin(7,RSIPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Relative Strength Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i,counted_bars=IndicatorCounted();
   double rel,negative,positive;
   
   SetLevelValue(0,Level1);
   SetLevelValue(1,Level2);
   SetLevelValue(2,Level3);
   SetLevelValue(3,Level4);
   SetLevelValue(4,Level5);
   SetLevelStyle(2,2,CLR_NONE);
   
  //----
   if(Bars<=RSIPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=RSIPeriod;i++) RSIBuffer[Bars-i]=0.0;
//----
   i=Bars-RSIPeriod-1;
   if(counted_bars>=RSIPeriod) i=Bars-counted_bars-1;
   while(i>=0)
     {
      double sumn=0.0,sump=0.0;
      if(i==Bars-RSIPeriod-1)
        {
         int k=Bars-2;
         //---- initial accumulation
         while(k>=i)
           {
            rel=Close[k]-Close[k+1];
            if(rel>0) sump+=rel;
            else      sumn-=rel;
            k--;
           }
         positive=sump/RSIPeriod;
         negative=sumn/RSIPeriod;
        }
      else
        {
         //---- smoothed moving average
         rel=Close[i]-Close[i+1];
         if(rel>0) sump=rel;
         else      sumn=-rel;
         positive=(PosBuffer[i+1]*(RSIPeriod-1)+sump)/RSIPeriod;
         negative=(NegBuffer[i+1]*(RSIPeriod-1)+sumn)/RSIPeriod;
        }
      PosBuffer[i]=positive;
      NegBuffer[i]=negative;
      if(negative==0.0) RSIBuffer[i]=0.0;
      else RSIBuffer[i]=100.0-100.0/(1+positive/negative);
      
   Buffer1[i]=Level1;
   Buffer2[i]=Level2;
   Buffer3[i]=Level3;
   Buffer4[i]=Level4;
   Buffer5[i]=Level5;
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+